"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Sha256 = void 0;
var sha256_1 = require("@noble/hashes/sha256");
/**
 * The `Sha256` class provides an interface for generating SHA-256 hash digests.
 *
 * This class utilizes the '@noble/hashes/sha256' function to generate hash digests
 * of the provided data. The SHA-256 algorithm is widely used in cryptographic
 * applications to produce a fixed-size 256-bit (32-byte) hash.
 *
 * The methods of this class are asynchronous and return Promises. They use the Uint8Array
 * type for input data and the resulting digest, ensuring a consistent interface
 * for binary data processing.
 *
 * @example
 * ```ts
 * const data = new Uint8Array([...]);
 * const hash = await Sha256.digest({ data });
 * ```
 */
var Sha256 = /** @class */ (function () {
    function Sha256() {
    }
    /**
     * Generates a SHA-256 hash digest for the given data.
     *
     * @remarks
     * This method produces a hash digest using the SHA-256 algorithm. The resultant digest
     * is deterministic, meaning the same data will always produce the same hash, but
     * is computationally infeasible to regenerate the original data from the hash.
     *
     * @example
     * ```ts
     * const data = new Uint8Array([...]);
     * const hash = await Sha256.digest({ data });
     * ```
     *
     * @param params - The parameters for the hashing operation.
     * @param params.data - The data to hash, represented as a Uint8Array.
     *
     * @returns A Promise that resolves to the SHA-256 hash digest of the provided data as a Uint8Array.
     */
    Sha256.digest = function (_a) {
        return __awaiter(this, arguments, void 0, function (_b) {
            var hash;
            var data = _b.data;
            return __generator(this, function (_c) {
                hash = (0, sha256_1.sha256)(data);
                return [2 /*return*/, hash];
            });
        });
    };
    return Sha256;
}());
exports.Sha256 = Sha256;
//# sourceMappingURL=sha256.js.map