/**
 * Represents an identifier for a cryptographic algorithm.
 *
 * This is typically a string that specifies the name of the algorithm, such as 'ES256K', 'A256GCM',
 * 'SHA-256', etc. It's used to refer to the specific algorithm in cryptographic operations.
 */
export type AlgorithmIdentifier = string;
/**
 * Denotes an identifier for a cryptographic key.
 *
 * It's a string used to uniquely identify a key within a given context, such as in key management
 * systems (KMS) or cryptographic protocols. This identifier can be a simple string, a UUID, a URI,
 * or any format chosen to suit the application's needs.
 */
export type KeyIdentifier = string;
//# sourceMappingURL=identifier.d.ts.map